/***************************************************************************
 *            traInput.cpp
 *
 *  Copyright  2006  Florent Berthaut
 *  florentberthaut@no-log.org
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "traInput.h"
#include <iostream>
#include <cstdlib>
#include <vector>

using namespace std;

traInput::traInput():swapIndex(0),swapFilled(false)
{	
}

traInput::~traInput()
{
}

bool traInput::getSwapFilled()
{
	return swapFilled;
}

void traInput::setSwapFilled(bool f)
{
	swapFilled=f;
}
			
int traInput::getSwapIndex()
{
	return swapIndex;
}

void traInput::setSwapIndex(int i)
{
	swapIndex = i;
}
	
void traInput::setSliceNbSample(int s)
{
	
}

void traInput::fillProcessBuffer(int state,int inp,int nbFrames, jack_default_audio_sample_t*** buf)
{
	if(processBuffer[state][0].size()!=nbFrames)
	{
		processBuffer[state][0].resize(nbFrames);
		processBuffer[state][1].resize(nbFrames);
	}

	for (int i=0;i<nbFrames;++i)
	{
		processBuffer[state][0][i] = buf[0][inp][i] ;
		processBuffer[state][1][i] = buf[0][inp][i];
	}
}

void traInput::processSwap(int state)
{
	//if swapbuffer filled with the other slice
	if(swapFilled)
	{
		int i=0;
		//FADE IN ?
		while(swapIndex < NB_CROSSFADE_SAMPLES && i<processBuffer[state][0].size())
		{
			jack_default_audio_sample_t vol=((double)(NB_CROSSFADE_SAMPLES)-(double)(swapIndex))/(double)NB_CROSSFADE_SAMPLES;
			for(int channel=0;channel<2;++channel)
			{
				sw=swapBuffer[state][channel][swapIndex];
				swapBuffer[state][channel][swapIndex]=processBuffer[state][channel][i];
				processBuffer[state][channel][i]=sw*vol+processBuffer[state][channel][i]*(1.0-vol);	
			}
			++swapIndex;	
			++i;	
		}

		//NORMAL
		while(swapIndex < swapBuffer[state][0].size() - NB_CROSSFADE_SAMPLES && i<processBuffer[state][0].size())
		{
			for(int channel=0;channel<2;++channel)
			{
				sw=swapBuffer[state][channel][swapIndex];
				swapBuffer[state][channel][swapIndex]=processBuffer[state][channel][i];
				processBuffer[state][channel][i]=sw;	
			}
			++swapIndex;	
			++i;	
		}


		//FADE OUT ?
		while(swapIndex < swapBuffer[state][0].size() && i<processBuffer[state][0].size())
		{
			jack_default_audio_sample_t vol=((double)(NB_CROSSFADE_SAMPLES)-(double)(swapBuffer[state][0].size() - swapIndex))/(double)NB_CROSSFADE_SAMPLES;
			for(int channel=0;channel<2;++channel)
			{
				sw=swapBuffer[state][channel][swapIndex];
				swapBuffer[state][channel][swapIndex]=processBuffer[state][channel][i];
				processBuffer[state][channel][i]=sw*(1.0-vol)+processBuffer[state][channel][i]*vol;	
			}
			++swapIndex;	
			++i;	
		}

		if(swapIndex == swapBuffer[state][0].size() - 1)
		{
			swapIndex=0;
		}
	}
	else
	{
		//fill the swap buffer 
		for(unsigned int i=0;i<processBuffer[state][0].size() && swapIndex < swapBuffer[state][0].size();++i)
		{
			for(int channel=0;channel<2;++channel)
			{
				swapBuffer[state][channel][swapIndex]=processBuffer[state][channel][i];
			}
			++swapIndex;	
		}
		if(swapIndex == swapBuffer[state][0].size() - 1)
		{
			swapIndex=0;
			swapFilled=true;
		}
	}
}

void traInput::processRepeat(int state)
{

	//A REVOIR, ENREGISTRER LA PLUS GRANDE DUREE DE SLICE POSSIBLE + CROSSFADE_NB_SAMPLEs
	//FAIRE LE CROSSFADE PLUTOT A LA LECTURE -> CHANGEMENT DE SLIC

/*

	//if swapbuffer filled with the other slice
	if(repeatFilled)
	{
		int i=0;
		while(repeatIndex < repeatBuffer[state][0].size() && i<processBuffer[state][0].size())
		{
			for(int channel=0;channel<2;++channel)
			{
				processBuffer[state][channel][i]=repeatBuffer[state][channel][repeatIndex];
			}
			++repeatIndex;	
			++i;	
		}
		if(repeatIndex == repeatBuffer[state][0].size() - 1)
		{
			repeatIndex=0;
		}
		
	}
	else
	{
		int i=0;

		//NORMAL
		while(repeatIndex < repeatBuffer[state][0].size() && i<processBuffer[state][0].size())
		{
			for(int channel=0;channel<2;++channel)
			{
				repeatBuffer[state][channel][repeatIndex]=processBuffer[state][channel][i];
			}
			++repeatIndex;	
			++i;	
		}


		//FADE OUT ?
		while(repeatIndex < repeatBuffer[state][0].size() + NB_CROSSFADE_SAMPLES && i<processBuffer[state][0].size())
		{
			int pos = repeatIndex-repeatBuffer[state][0].size();
			jack_default_audio_sample_t vol=(double)pos/(double)NB_CROSSFADE_SAMPLES;
			for(int channel=0;channel<2;++channel)
			{
				repeatBuffer[state][channel][repeatIndex-repeatBuffer[state][0].size()i] = rt*(1.0-vol)+processBuffer[state][channel][i]*vol;
				processBuffer[state][channel][i]=rt*(1.0-vol)+processBuffer[state][channel][i]*vol;	
			}
			++repeatIndex;	
			++i;	
		}

		if(repeatIndex == repeatBuffer[state][0].size() + NB_CROSSFADE_SAMPLES - 1)
		{
			repeatIndex=0;
			repeatFilled=true;
		}
	}
	*/	
}

void traInput::processGranulize(int state)
{
	/*
	#define MAX_GRAINS_PER_BUFFER 10000 
	double buffer[MAX_GRAINS_PER_BUFFER][MAX_SAMPLES_PER_GRAIN];
	int bufferSize=5000,grainSize=1024;
	int curReadGrain=0,curReadSample=0;
	int curWriteSample=0,oldWriteGrain=0,newWriteGrain=0;
	int fadeTime=100;
	//get the new grains in the tab
	for (lSampleIndex = 0; lSampleIndex < SampleCount; lSampleIndex++)
	{
		buffer[curReadGrain][curReadSample] = (double)pfInput[lSampleIndex];
		if(curReadSample<grainSize)
			curReadSample++;
		else
			if(curReadGrain < bufferSize)
				curReadGrain++;
			else
				curReadGrain=0;
			curReadSample=0;
	}
  


	//send back random 
	for (lSampleIndex = 0; lSampleIndex < SampleCount; lSampleIndex++) 
	{
		if(curWriteSample > grainSize)
		{
			oldWriteGrain = newWriteGrain;
			curWriteSample=0;
			pfOutput[lSampleIndex]=buffer[newWriteGrain][curWriteSample];
		}
		else if(curWriteSample > (grainSize - fadeTime))
		{
			double newVolume = (curWriteSample - grainSize + fadeTime)/fadeTime;
			double oldVolume = 1.0 - newVolume; 
			
			pfOutput[lSampleIndex]= newVolume*buffer[newWriteGrain][grainSize - curWriteSample - fadeTime] + oldVolume*buffer[oldWriteGrain][curWriteSample];
			curWriteSample++;
		}
		else if(curWriteSample == (grainSize - fadeTime))
		{
			newWriteGrain = random(bufferSize);
			pfOutput[lSampleIndex]=buffer[oldWriteGrain][curWriteSample];
			curWriteSample++;
		}
		else
		{
			pfOutput[lSampleIndex]=buffer[newWriteGrain][curWriteSample];
			curWriteSample++;
		}
	}
	*/
}

