/***************************************************************************
 *            traInput.h
 *
 *  Copyright  2006  Florent Berthaut
 *  florentberthaut@no-log.org
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef TRA_INPUT_H
#define TRA_INPUT_H


#include <jack/jack.h>
#include <jack/thread.h>
#include <sys/time.h>
#include <vector>

#define NB_CROSSFADE_SAMPLES 100


class traInput
{
	public:
			traInput();
			~traInput();

			bool getSwapFilled();	
			void setSwapFilled(bool);	
			int getSwapIndex();
			void setSwapIndex(int);
			
			void setSliceNbSample(int);

			void fillProcessBuffer(int,int,int,jack_default_audio_sample_t*** buf);
			void processSwap(int);
			void processRepeat(int);
			void processGranulize(int);
	private:
			std::vector<jack_default_audio_sample_t> processBuffer[2][2];

			std::vector<jack_default_audio_sample_t> swapBuffer[2][2];
			jack_default_audio_sample_t sw;
			int swapIndex;
			bool swapFilled;

			std::vector<jack_default_audio_sample_t> repeatBuffer[2][2];
			jack_default_audio_sample_t rt;
			int repeatIndex;
			bool repeatFilled;

			bool selected[2];
};

#endif
