/***************************************************************************
 *          traParser.h
 *
 *  Copyright  2006  Florent Berthaut
 *  florentberthaut@no-log.org
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#ifndef TRAPARSER_H
#define TRAPARSER_H

#include <libxml/parser.h>
#include <libxml/tree.h>
#include <iostream>

class tranches;

class traParser
{
	public:
		traParser(tranches*);
		~traParser();
		int createTree(char*);
		int parseTree();
		int recParseTree(xmlNode*);
		
		int parse005(xmlNodePtr);
		int parseCurrent(xmlNodePtr);

		int parseInputs(xmlNodePtr);
		int parseOutputs(xmlNodePtr);
		int parseSlice(xmlNodePtr);
		int parseSwap(xmlNodePtr);
		int parseRepeat(xmlNodePtr);
		int parseGranulize(xmlNodePtr);
	
		int saveToFile(char*);

	private:
		
		char* fileName;
		xmlDocPtr doc;
		xmlNode *root_element;
		tranches *tra;
};


#endif
