/***************************************************************************
 *            execWindow.h
 *
 *  Mon Sep  4 09:56:39 2006
 *  Copyright  2006  Florent Berthaut
 *  florentberthaut@no-log.org
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Menu_Item.H>
#include <FL/Fl_Menu_Bar.H>
#include <FL/Fl_Progress.H>
#include <FL/Fl_File_Chooser.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Toggle_Button.H>
#include <FL/Fl_Slider.H>
#include <FL/Fl_Value_Slider.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Counter.H>
#include <FL/Fl_Check_Browser.H>
#include <FL/fl_ask.H>
#include <iostream>
#include <string>

#include "messageWindow.h"
#include "tardiFlFileBrowser.h"
 
#ifndef _EXECWINDOW_H
#define _EXECWINDOW_H

class tranches;

class execWindow : public Fl_Window 
{
  public:
			execWindow(int ,int ,const char*,tranches* );
			~execWindow();

  			static void statWindow(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbWindow(w);}	
			void cbWindow(Fl_Widget*);

			//menu callbacks
  			static void statOpen(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbOpen(w);}	
			void cbOpen(Fl_Widget*);
  			static void statSave(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbSave(w);}	
			void cbSave(Fl_Widget*);
  			static void statSaveAs(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbSaveAs(w);}	
			void cbSaveAs(Fl_Widget*);
  			static void statQuit(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbQuit(w);}	
			void cbQuit(Fl_Widget*);
  			static void statMessages(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbMessages(w);}	
			void cbMessages(Fl_Widget*);


			//tabs
  			static void statTabs(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbTabs(w);}	
			void cbTabs(Fl_Widget*);

			//setting tab
  			static void statSetMidiSel(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbSetMidiSel(w);}	
			void cbSetMidiSel(Fl_Widget*);
  			static void statSetMidiAct(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbSetMidiAct(w);}	
			void cbSetMidiAct(Fl_Widget*);
  			static void statSetMidiCC(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbSetMidiCC(w);}	
			void cbSetMidiCC(Fl_Widget*);
  			static void statSetMidiChan(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbSetMidiChan(w);}	
			void cbSetMidiChan(Fl_Widget*);
  			static void statSetMidiMin(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbSetMidiMin(w);}	
			void cbSetMidiMin(Fl_Widget*);
  			static void statSetMidiRoot(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbSetMidiRoot(w);}	
			void cbSetMidiRoot(Fl_Widget*);
  			static void statSetMidiMax(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbSetMidiMax(w);}	
			void cbSetMidiMax(Fl_Widget*);
  			static void statSetMidiPiano(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbSetMidiPiano(w);}	
			void cbSetMidiPiano(Fl_Widget*);
  			static void statSetMidiLearn(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbSetMidiLearn(w);}	
			void cbSetMidiLearn(Fl_Widget*);
  			static void statSetOutList(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbSetOutList(w);}	
			void cbSetOutList(Fl_Widget*);
  			static void statSetOutNew(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbSetOutNew(w);}	
			void cbSetOutNew(Fl_Widget*);
  			static void statSetOutRemove(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbSetOutRemove(w);}	
			void cbSetOutRemove(Fl_Widget*);
  			static void statSetOutName(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbSetOutName(w);}	
			void cbSetOutName(Fl_Widget*);
  			static void statSetInList(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbSetInList(w);}	
			void cbSetInList(Fl_Widget*);
  			static void statSetInNew(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbSetInNew(w);}	
			void cbSetInNew(Fl_Widget*);
  			static void statSetInRemove(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbSetInRemove(w);}	
			void cbSetInRemove(Fl_Widget*);
  			static void statSetInName(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbSetInName(w);}	
			void cbSetInName(Fl_Widget*);
			
			//exec tab
  			static void statExecIn(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbExecIn(w);}	
			void cbExecIn(Fl_Widget*);
  			static void statExecOut(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbExecOut(w);}	
			void cbExecOut(Fl_Widget*);
  			static void statExecSlice(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbExecSlice(w);}	
			void cbExecSlice(Fl_Widget*);
  			static void statExecSwap(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbExecSwap(w);}	
			void cbExecSwap(Fl_Widget*);
  			static void statExecSwapS1(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbExecSwapS1(w);}	
			void cbExecSwapS1(Fl_Widget*);
  			static void statExecSwapS2(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbExecSwapS2(w);}	
			void cbExecSwapS2(Fl_Widget*);
  			static void statExecRepeat(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbExecRepeat(w);}	
			void cbExecRepeat(Fl_Widget*);
  			static void statExecReverse(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbExecReverse(w);}	
			void cbExecReverse(Fl_Widget*);
  			static void statExecGran(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbExecRepeat(w);}	
			void cbExecGran(Fl_Widget*);
  			static void statExecGranSize(Fl_Widget* w,void* f){execWindow *tmpf = static_cast<execWindow *>(f);tmpf->cbExecGranSize(w);}	
			void cbExecGranSize(Fl_Widget*);
			
			void showMessage(bool,std::string);
			void setStatus(std::string);
			void setTitle(std::string);
			void init();
			void reset();
			void changeInput(int);
			void changeOutput(int);
			void changeSlice(int,int);
			void toggleExecReverse(int);
			void toggleExecRepeat(int);
			void learnMidi(int,int);
			void updateMidi();
  private:
			tranches *tra;	
			bool fileSaved;

			Fl_Menu_Bar *menu;

			messageWindow* messages;

			Fl_Group* status;			
			std::string statusStr;

			Fl_Tabs * tabs;

			Fl_Group* setTab;
			Fl_Choice *setMidiSel;
			Fl_Check_Button *setMidiAct;
			Fl_Counter *setMidiCC;
			Fl_Counter *setMidiMax;
			Fl_Counter *setMidiRoot;
			Fl_Counter *setMidiMin;
			Fl_Counter *setMidiChan;
			Fl_Button *setMidiLearn;
  			Fl_Hold_Browser *setOutList;
			Fl_Button *setOutNew;
			Fl_Button *setOutRemove;
			Fl_Input *setOutName;
  			Fl_Hold_Browser *setInList;
			Fl_Button *setInNew;
			Fl_Button *setInRemove;
			Fl_Input *setInName;

			Fl_Group* execTab;
			Fl_Group* execMixGroup;
			//Fl_Check_Browser *execIn;
			Fl_Choice *execIn;
			Fl_Choice *execOut;
			Fl_Group* execSliceGroup;
  			Fl_Output *execSliceDis;
			Fl_Slider *execSlice;
			Fl_Button *execSwap;
			Fl_Group* execSwapGroup;
			Fl_Value_Slider *execSwapS1;
			Fl_Value_Slider *execSwapS2;
			Fl_Group* execRepeatGroup;
			Fl_Toggle_Button *execRepeat;
			Fl_Toggle_Button *execReverse;
			Fl_Group* execGranGroup;
			Fl_Button *execGran;
			Fl_Value_Slider *execGranSize;
};

#endif /* _EXECWINDOW_H */
